<?php

/**
 * @file
 * Theme settings for the ninesixtyfive
 */
function ninesixtyfive_form_system_theme_settings_alter(&$form, &$form_state) {
  
  $form['#submit'] = array('drupal_theme_rebuild', 'ninesixtyfive_clear_cache');
  
  /**
   * General Settings
   */
  $form['ninesixtyfive_general'] = array(
    '#type' => 'fieldset',
    '#title' => t('General'),
  );
  $form['ninesixtyfive_general']['ninesixtyfive_feed_icons'] = array(
    '#type' => 'checkbox',
    '#title' => t('Display Feed Icons'),
    '#default_value' => theme_get_setting('ninesixtyfive_feed_icons'),
  );
  /**
   * SASS Settings
   */
  $form['ninesixtyfive_sass'] = array(
    '#type' => 'fieldset',
    '#title' => t('SASS / SCSS'),
  );
  $form['ninesixtyfive_sass']['ninesixtyfive_sass'] = array(
    '#type' => 'checkbox',
    '#title' => t('Compile SASS / SCSS to CSS'),
    '#description' => t('SASS integration - uncheck if you are already using a different sass compiler.'),
    '#default_value' => theme_get_setting('ninesixtyfive_sass'),
  );
  $form['ninesixtyfive_sass']['ninesixtyfive_devel'] = array(
    '#type' => 'checkbox',
    '#title' => t('Development mode - Recompile all SASS / SCSS files on every change (+FireSass support).'),
    '#description' => t('SASS Development - Recompile SASS / SCSS files every time you change them and get <a href="!link">FireSass</a> support. WARNING: css output is way bigger, use only in development.', array('!link' => 'https://addons.mozilla.org/en-US/firefox/addon/firesass-for-firebug/')),
    '#default_value' => theme_get_setting('ninesixtyfive_devel'),
  );
  $form['ninesixtyfive_sass']['ninesixtyfive_flush'] = array(
    '#type' => 'submit',
    '#value' => 'Recompile SASS / SCSS files',
    '#submit' => array('ninesixtyfive_clear_cache'),
  );
  /**
   * HTML5 Settings
   */
  $form['ninesixtyfive_html5'] = array(
    '#type' => 'fieldset',
    '#title' => t('HTML5 support'),
  );
  $form['ninesixtyfive_html5']['ninesixtyfive_force_ie'] = array(
    '#type' => 'checkbox',
    '#title' => t('Always force latest IE rendering engine (even in intranet) & Chrome Frame'),
    '#default_value' => theme_get_setting('ninesixtyfive_force_ie'),
  );
  $form['ninesixtyfive_html5']['ninesixtyfive_html5shiv'] = array(
    '#type' => 'checkbox',
    '#title' => t('Enable HTML5 elements in IE'),
    '#default_value' => theme_get_setting('ninesixtyfive_html5shiv'),
  );
  /**
   * Responsive Layout Settings
   */
  $form['ninesixtyfive_layout'] = array(
    '#type' => 'fieldset',
    '#title' => t('Responsive Layout'),
  );
  $form['ninesixtyfive_layout']['ninesixtyfive_responsive'] = array(
    '#type' => 'checkbox',
    '#title' => t('Enable responsive layout'),
    '#description' => t("Disable if you don't want your site layout to adapt to small devices"),
    '#default_value' => theme_get_setting('ninesixtyfive_responsive'),
  );
  $form['ninesixtyfive_layout']['ninesixtyfive_responsive_narrow'] = array(
    '#type' => 'textfield',
    '#size' => 10,
    '#title' => t('Narrow width'),
    '#description' => t("Set the first breakpoint in which the layout will adapt, this should probably be your max page width"),
    '#default_value' => theme_get_setting('ninesixtyfive_responsive_narrow'),
  );
  $form['ninesixtyfive_layout']['ninesixtyfive_responsive_narrower'] = array(
    '#type' => 'textfield',
    '#size' => 10,
    '#title' => t('Narrower width'),
    '#description' => t("Set the second breakpoint in which the layout will adapt"),
    '#default_value' => theme_get_setting('ninesixtyfive_responsive_narrower'),
  );
  $form['ninesixtyfive_layout']['ninesixtyfive_responsive_narrowest'] = array(
    '#type' => 'textfield',
    '#size' => 10,
    '#title' => t('Narrowest width'),
    '#description' => t("Set the third breakpoint in which the layout will adapt"),
    '#default_value' => theme_get_setting('ninesixtyfive_responsive_narrowest'),
  );
  /**
   * Development Settings
   */
  $form['ninesixtyfive_development'] = array(
    '#type' => 'fieldset',
    '#title' => t('Development'),
  );
  $form['ninesixtyfive_development']['ninesixtyfive_clear_registry'] = array(
    '#type' => 'checkbox',
    '#title' => t('Rebuild theme registry on every page request.'),
    '#description' => t('During theme development, it can be very useful to continuously <a href="!link">rebuild the theme registry</a>. WARNING: this is a huge performance penalty and must be turned off on production websites.', array('!link' => 'http://drupal.org/node/173880#theme-registry')),
    '#default_value' => theme_get_setting('ninesixtyfive_clear_registry'),
  );
  $form['ninesixtyfive_development']['ninesixtyfive_show_grid'] = array(
    '#type' => 'checkbox',
    '#title' => t('Show grid background layer.'),
    '#description' => t('Display a visible background grid, for easier elements positioning'),
    '#default_value' => theme_get_setting('ninesixtyfive_show_grid'),
  );  
  /**
   * Breadcrumb settings
   */
  $form['ninesixtyfive_breadcrumb'] = array(
    '#type' => 'fieldset',
    '#title' => t('Breadcrumb'),
  );

  $form['ninesixtyfive_breadcrumb']['ninesixtyfive_breadcrumb_hideonlyfront'] = array(
    '#type' => 'checkbox',
    '#title' => t('Hide the breadcrumb if the breadcrumb only contains the link to the front page.'),
    '#default_value' => theme_get_setting('ninesixtyfive_breadcrumb_hideonlyfront'),
  );
  
  $form['ninesixtyfive_breadcrumb']['ninesixtyfive_breadcrumb_showtitle'] = array(
    '#type' => 'checkbox',
    '#title' => t('Show page title on breadcrumb.'),
    '#default_value' => theme_get_setting('ninesixtyfive_breadcrumb_showtitle'),
  );

  $form['ninesixtyfive_breadcrumb']['ninesixtyfive_breadcrumb_separator'] = array(
    '#type' => 'textfield',
    '#title' => t('Breadcrumb separator'),
    '#default_value' => theme_get_setting('ninesixtyfive_breadcrumb_separator'),
  );
}

/**
 * Deletes old cached SCSS files.
 */
function ninesixtyfive_clear_cache() {
  variable_del('ninesixtyfive_cache');
  file_scan_directory('public://ninesixtyfive', '/.*/', array('callback' => 'drupal_delete_file_if_stale'));
}
